// This file is common to the XML Moo Database browser and Moo Canada's IDE.

var TreeFrame, ListFrame, CodeFrame, XmlDoc;

function onloadBody() {
  TreeFrame = this.frames[0].frames[0];
  ListFrame = this.frames[0].frames[1];
  CodeFrame = this.frames[1];
  
  // Look in the URL for a requested database.
  var db = window.location.search;
  if (db) {
    // Trim off the '?' and unescape the URI encoding
    db = decodeURI(db.substring(1));
  }
  if (!db) {
    // No database found.  Ask the user for one instead.
    db = window.prompt("Enter the filename of an XML Moo Database", "encore.xml", "Moo Database");
  }
  if (db) {
    loadXML(db);
  }
}

function loadXML(url) {
  if (window.ActiveXObject) {
    // IE
    XmlDoc = new ActiveXObject("Microsoft.XMLDOM");
    XmlDoc.async = false;
    XmlDoc.load(url);
    onloadXML();
  } else if (document.implementation && document.implementation.createDocument) {
    // Gecko, Opera, Safari, etc.
    XmlDoc = document.implementation.createDocument("", "", null);
    XmlDoc.load(url);
    XmlDoc.onload = onloadXML;
  } else {
    alert("Unsupported browser; can't load XML.");
  }
}

function onloadXML() {
  TreeFrame.clear();
  var objectList = XmlDoc.getElementsByTagName("OBJECT");
  var objectListLength = objectList.length;
  for (var x = 0; x < objectListLength; x++) {
    TreeFrame.treeUpdateId(objectList[x].getAttribute("ID"), XmlDoc);
  }
  TreeFrame.treeFoldAll(false);
}

function getXmlNodeById(id) {
  var node;
  if (XmlDoc.getElementById) {
    // Gecko, Opera, Safari, etc.
    node = XmlDoc.getElementById(id);
  } else {
    // IE
    node = XmlDoc.nodeFromID(id);
  }
  return node;
}

function getXmlNameFromNode(xmlNode) {
  var childXmlNodeLength = xmlNode.childNodes.length;
  var childXmlNode
  for (var x = 0; x < childXmlNodeLength; x++) {
    childXmlNode = xmlNode.childNodes[x];
    if (childXmlNode.nodeName == "NAME" && childXmlNode.firstChild) {
      return childXmlNode.firstChild.nodeValue;
    }
  }
  return "";
}
